Index: /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.LibSVM/1.6.3/LibSVM-1.6.3/Training.cs
===================================================================
--- /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.LibSVM/1.6.3/LibSVM-1.6.3/Training.cs	(revision 4067)
+++ /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.LibSVM/1.6.3/LibSVM-1.6.3/Training.cs	(revision 4068)
@@ -19,209 +19,191 @@
 
 using System;
-using System.Collections.Generic;
-
-namespace SVM
-{
-    /// <summary>
-    /// Class containing the routines to train SVM models.
-    /// </summary>
-    public static class Training
-    {
-        /// <summary>
-        /// Whether the system will output information to the console during the training process.
-        /// </summary>
-        public static bool IsVerbose
-        {
-            get
-            {
-                return Procedures.IsVerbose;
+
+namespace SVM {
+  /// <summary>
+  /// Class containing the routines to train SVM models.
+  /// </summary>
+  public static class Training {
+    /// <summary>
+    /// Whether the system will output information to the console during the training process.
+    /// </summary>
+    public static bool IsVerbose {
+      get {
+        return Procedures.IsVerbose;
+      }
+      set {
+        Procedures.IsVerbose = value;
+      }
+    }
+
+    private static double doCrossValidation(Problem problem, Parameter parameters, int nr_fold, bool shuffleTraining) {
+      int i;
+      double[] target = new double[problem.Count];
+      Procedures.svm_cross_validation(problem, parameters, nr_fold, target, shuffleTraining);
+      int total_correct = 0;
+      double total_error = 0;
+      //double sumv = 0, sumy = 0, sumvv = 0, sumyy = 0, sumvy = 0;
+      if (parameters.SvmType == SvmType.EPSILON_SVR || parameters.SvmType == SvmType.NU_SVR) {
+        for (i = 0; i < problem.Count; i++) {
+          double y = problem.Y[i];
+          double v = target[i];
+          total_error += (v - y) * (v - y);
+          //sumv += v;
+          //sumy += y;
+          //sumvv += v * v;
+          //sumyy += y * y;
+          //sumvy += v * y;
+        }
+        return total_error / problem.Count; // return MSE
+        // (problem.Count * sumvy - sumv * sumy) / (Math.Sqrt(problem.Count * sumvv - sumv * sumv) * Math.Sqrt(problem.Count * sumyy - sumy * sumy));
+      } else
+        for (i = 0; i < problem.Count; i++)
+          if (target[i] == problem.Y[i])
+            ++total_correct;
+      return (double)total_correct / problem.Count;
+    }
+    /// <summary>
+    /// Legacy.  Allows use as if this was svm_train.  See libsvm documentation for details on which arguments to pass.
+    /// </summary>
+    /// <param name="args"></param>
+    [Obsolete("Provided only for legacy compatibility, use the other Train() methods")]
+    public static void Train(params string[] args) {
+      Parameter parameters;
+      Problem problem;
+      bool crossValidation;
+      int nrfold;
+      string modelFilename;
+      parseCommandLine(args, out parameters, out problem, out crossValidation, out nrfold, out modelFilename);
+      if (crossValidation)
+        PerformCrossValidation(problem, parameters, nrfold, true);
+      else Model.Write(modelFilename, Train(problem, parameters));
+    }
+
+    /// <summary>
+    /// Performs cross validation.
+    /// </summary>
+    /// <param name="problem">The training data</param>
+    /// <param name="parameters">The parameters to test</param>
+    /// <param name="nrfold">The number of cross validations to use</param>
+    /// <returns>The cross validation score</returns>
+    public static double PerformCrossValidation(Problem problem, Parameter parameters, int nrfold, bool shuffleTraining) {
+      string error = Procedures.svm_check_parameter(problem, parameters);
+      if (error == null)
+        return doCrossValidation(problem, parameters, nrfold, shuffleTraining);
+      else throw new Exception(error);
+    }
+
+    /// <summary>
+    /// Trains a model using the provided training data and parameters.
+    /// </summary>
+    /// <param name="problem">The training data</param>
+    /// <param name="parameters">The parameters to use</param>
+    /// <returns>A trained SVM Model</returns>
+    public static Model Train(Problem problem, Parameter parameters) {
+      string error = Procedures.svm_check_parameter(problem, parameters);
+
+      if (error == null)
+        return Procedures.svm_train(problem, parameters);
+      else throw new Exception(error);
+    }
+
+    private static void parseCommandLine(string[] args, out Parameter parameters, out Problem problem, out bool crossValidation, out int nrfold, out string modelFilename) {
+      int i;
+
+      parameters = new Parameter();
+      // default values
+
+      crossValidation = false;
+      nrfold = 0;
+
+      // parse options
+      for (i = 0; i < args.Length; i++) {
+        if (args[i][0] != '-')
+          break;
+        ++i;
+        switch (args[i - 1][1]) {
+
+          case 's':
+            parameters.SvmType = (SvmType)int.Parse(args[i]);
+            break;
+
+          case 't':
+            parameters.KernelType = (KernelType)int.Parse(args[i]);
+            break;
+
+          case 'd':
+            parameters.Degree = int.Parse(args[i]);
+            break;
+
+          case 'g':
+            parameters.Gamma = double.Parse(args[i]);
+            break;
+
+          case 'r':
+            parameters.Coefficient0 = double.Parse(args[i]);
+            break;
+
+          case 'n':
+            parameters.Nu = double.Parse(args[i]);
+            break;
+
+          case 'm':
+            parameters.CacheSize = double.Parse(args[i]);
+            break;
+
+          case 'c':
+            parameters.C = double.Parse(args[i]);
+            break;
+
+          case 'e':
+            parameters.EPS = double.Parse(args[i]);
+            break;
+
+          case 'p':
+            parameters.P = double.Parse(args[i]);
+            break;
+
+          case 'h':
+            parameters.Shrinking = int.Parse(args[i]) == 1;
+            break;
+
+          case 'b':
+            parameters.Probability = int.Parse(args[i]) == 1;
+            break;
+
+          case 'v':
+            crossValidation = true;
+            nrfold = int.Parse(args[i]);
+            if (nrfold < 2) {
+              throw new ArgumentException("n-fold cross validation: n must >= 2");
             }
-            set
-            {
-                Procedures.IsVerbose = value;
-            }
+            break;
+
+          case 'w':
+            parameters.Weights[int.Parse(args[i - 1].Substring(2))] = double.Parse(args[1]);
+            break;
+
+          default:
+            throw new ArgumentException("Unknown Parameter");
         }
-
-        private static double doCrossValidation(Problem problem, Parameter parameters, int nr_fold, bool shuffleTraining)
-        {
-            int i;
-            double[] target = new double[problem.Count];
-            Procedures.svm_cross_validation(problem, parameters, nr_fold, target, shuffleTraining);
-            int total_correct = 0;
-            double total_error = 0;
-            //double sumv = 0, sumy = 0, sumvv = 0, sumyy = 0, sumvy = 0;
-            if (parameters.SvmType == SvmType.EPSILON_SVR || parameters.SvmType == SvmType.NU_SVR)
-            {
-                for (i = 0; i < problem.Count; i++)
-                {
-                    double y = problem.Y[i];
-                    double v = target[i];
-                    total_error += (v - y) * (v - y);
-                    //sumv += v;
-                    //sumy += y;
-                    //sumvv += v * v;
-                    //sumyy += y * y;
-                    //sumvy += v * y;
-                }
-                return total_error / problem.Count; // return MSE
-              // (problem.Count * sumvy - sumv * sumy) / (Math.Sqrt(problem.Count * sumvv - sumv * sumv) * Math.Sqrt(problem.Count * sumyy - sumy * sumy));
-            }
-            else
-                for (i = 0; i < problem.Count; i++)
-                    if (target[i] == problem.Y[i])
-                        ++total_correct;
-            return (double)total_correct / problem.Count;
-        }
-        /// <summary>
-        /// Legacy.  Allows use as if this was svm_train.  See libsvm documentation for details on which arguments to pass.
-        /// </summary>
-        /// <param name="args"></param>
-        [Obsolete("Provided only for legacy compatibility, use the other Train() methods")]
-        public static void Train(params string[] args)
-        {
-            Parameter parameters;
-            Problem problem;
-            bool crossValidation;
-            int nrfold;
-            string modelFilename;
-            parseCommandLine(args, out parameters, out problem, out crossValidation, out nrfold, out modelFilename);
-            if (crossValidation)
-                PerformCrossValidation(problem, parameters, nrfold, true);
-            else Model.Write(modelFilename, Train(problem, parameters));
-        }
-
-        /// <summary>
-        /// Performs cross validation.
-        /// </summary>
-        /// <param name="problem">The training data</param>
-        /// <param name="parameters">The parameters to test</param>
-        /// <param name="nrfold">The number of cross validations to use</param>
-        /// <returns>The cross validation score</returns>
-        public static double PerformCrossValidation(Problem problem, Parameter parameters, int nrfold, bool shuffleTraining)
-        {
-            string error = Procedures.svm_check_parameter(problem, parameters);
-            if (error == null)
-                return doCrossValidation(problem, parameters, nrfold, shuffleTraining);
-            else throw new Exception(error);
-        }
-
-        /// <summary>
-        /// Trains a model using the provided training data and parameters.
-        /// </summary>
-        /// <param name="problem">The training data</param>
-        /// <param name="parameters">The parameters to use</param>
-        /// <returns>A trained SVM Model</returns>
-        public static Model Train(Problem problem, Parameter parameters)
-        {
-            string error = Procedures.svm_check_parameter(problem, parameters);
-
-            if (error == null)
-                return Procedures.svm_train(problem, parameters);
-            else throw new Exception(error);
-        }
-
-        private static void parseCommandLine(string[] args, out Parameter parameters, out Problem problem, out bool crossValidation, out int nrfold, out string modelFilename)
-        {
-            int i;
-
-            parameters = new Parameter();
-            // default values
-
-            crossValidation = false;
-            nrfold = 0;
-
-            // parse options
-            for (i = 0; i < args.Length; i++)
-            {
-                if (args[i][0] != '-')
-                    break;
-                ++i;
-                switch (args[i - 1][1])
-                {
-
-                    case 's':
-                        parameters.SvmType = (SvmType)int.Parse(args[i]);
-                        break;
-
-                    case 't':
-                        parameters.KernelType = (KernelType)int.Parse(args[i]);
-                        break;
-
-                    case 'd':
-                        parameters.Degree = int.Parse(args[i]);
-                        break;
-
-                    case 'g':
-                        parameters.Gamma = double.Parse(args[i]);
-                        break;
-
-                    case 'r':
-                        parameters.Coefficient0 = double.Parse(args[i]);
-                        break;
-
-                    case 'n':
-                        parameters.Nu = double.Parse(args[i]);
-                        break;
-
-                    case 'm':
-                        parameters.CacheSize = double.Parse(args[i]);
-                        break;
-
-                    case 'c':
-                        parameters.C = double.Parse(args[i]);
-                        break;
-
-                    case 'e':
-                        parameters.EPS = double.Parse(args[i]);
-                        break;
-
-                    case 'p':
-                        parameters.P = double.Parse(args[i]);
-                        break;
-
-                    case 'h':
-                        parameters.Shrinking = int.Parse(args[i]) == 1;
-                        break;
-
-                    case 'b':
-                        parameters.Probability = int.Parse(args[i]) == 1;
-                        break;
-
-                    case 'v':
-                        crossValidation = true;
-                        nrfold = int.Parse(args[i]);
-                        if (nrfold < 2)
-                        {
-                            throw new ArgumentException("n-fold cross validation: n must >= 2");
-                        }
-                        break;
-
-                    case 'w':
-                        parameters.Weights[int.Parse(args[i - 1].Substring(2))] = double.Parse(args[1]);
-                        break;
-
-                    default:
-                        throw new ArgumentException("Unknown Parameter");
-                }
-            }
-
-            // determine filenames
-
-            if (i >= args.Length)
-                throw new ArgumentException("No input file specified");
-
-            problem = Problem.Read(args[i]);
-
-            if (parameters.Gamma == 0)
-                parameters.Gamma = 1.0 / problem.MaxIndex;
-
-            if (i < args.Length - 1)
-                modelFilename = args[i + 1];
-            else
-            {
-                int p = args[i].LastIndexOf('/') + 1;
-                modelFilename = args[i].Substring(p) + ".model";
-            }
-        }
-    }
+      }
+
+      // determine filenames
+
+      if (i >= args.Length)
+        throw new ArgumentException("No input file specified");
+
+      problem = Problem.Read(args[i]);
+
+      if (parameters.Gamma == 0)
+        parameters.Gamma = 1.0 / problem.MaxIndex;
+
+      if (i < args.Length - 1)
+        modelFilename = args[i + 1];
+      else {
+        int p = args[i].LastIndexOf('/') + 1;
+        modelFilename = args[i].Substring(p) + ".model";
+      }
+    }
+  }
 }
Index: /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/HeuristicLab.Netron-3.0.2672.12446/Ants.cs
===================================================================
--- /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/HeuristicLab.Netron-3.0.2672.12446/Ants.cs	(revision 4067)
+++ /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/HeuristicLab.Netron-3.0.2672.12446/Ants.cs	(revision 4068)
@@ -29,10 +29,6 @@
 #endregion
 
-using System;
-using System.Collections.Generic;
-using System.Linq;
-using System.Text;
+using System.Drawing;
 using System.Drawing.Drawing2D;
-using System.Drawing;
 using Netron.Diagramming.Core;
 
Index: /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/HeuristicLab.Netron-3.0.2672.12446/Controller.cs
===================================================================
--- /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/HeuristicLab.Netron-3.0.2672.12446/Controller.cs	(revision 4067)
+++ /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/HeuristicLab.Netron-3.0.2672.12446/Controller.cs	(revision 4068)
@@ -30,7 +30,4 @@
 
 using System;
-using System.Collections.Generic;
-using System.Linq;
-using System.Text;
 using Netron.Diagramming.Core;
 
Index: /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/HeuristicLab.Netron-3.0.2672.12446/ExpandableIconMaterial.cs
===================================================================
--- /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/HeuristicLab.Netron-3.0.2672.12446/ExpandableIconMaterial.cs	(revision 4067)
+++ /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/HeuristicLab.Netron-3.0.2672.12446/ExpandableIconMaterial.cs	(revision 4068)
@@ -1,9 +1,6 @@
 ﻿using System;
-using System.Collections.Generic;
-using System.Linq;
-using System.Text;
-using Netron.Diagramming.Core;
 using System.Drawing;
 using System.Windows.Forms;
+using Netron.Diagramming.Core;
 
 namespace HeuristicLab.Netron {
@@ -31,5 +28,5 @@
           if (value) {
             this.Icon = this.collapsedBitmap;
-          } else 
+          } else
             this.Icon = this.expandedBitmap;
           collapsed = value;
Index: /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/HeuristicLab.Netron-3.0.2672.12446/Ghosts.cs
===================================================================
--- /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/HeuristicLab.Netron-3.0.2672.12446/Ghosts.cs	(revision 4067)
+++ /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/HeuristicLab.Netron-3.0.2672.12446/Ghosts.cs	(revision 4068)
@@ -30,9 +30,6 @@
 
 using System;
-using System.Collections.Generic;
-using System.Linq;
-using System.Text;
+using System.Drawing;
 using Netron.Diagramming.Core;
-using System.Drawing;
 
 namespace HeuristicLab.Netron {
@@ -203,5 +200,5 @@
         return Rectangle.FromLTRB(Math.Min(mStart.X, mEnd.X), Math.Min(mStart.Y, mEnd.Y), Math.Max(mStart.X, mEnd.X), Math.Max(mStart.Y, mEnd.Y));
       }
-      set { 
+      set {
         //was orginally empty
         throw new NotImplementedException();
Index: /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/HeuristicLab.Netron-3.0.2672.12446/HeuristicLabNetronPlugin.cs
===================================================================
--- /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/HeuristicLab.Netron-3.0.2672.12446/HeuristicLabNetronPlugin.cs	(revision 4067)
+++ /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/HeuristicLab.Netron-3.0.2672.12446/HeuristicLabNetronPlugin.cs	(revision 4068)
@@ -20,8 +20,4 @@
 #endregion
 
-using System;
-using System.Collections.Generic;
-using System.Linq;
-using System.Text;
 
 using HeuristicLab.PluginInfrastructure;
@@ -31,5 +27,5 @@
   [PluginFile("HeuristicLab.Netron-3.0.2672.12446.dll", PluginFileType.Assembly)]
   [PluginFile("Netron.Diagramming.Core-3.0.2672.12446.dll", PluginFileType.Assembly)]
-  [PluginFile("Netron.Diagramming.Core License.txt",PluginFileType.License)]
+  [PluginFile("Netron.Diagramming.Core License.txt", PluginFileType.License)]
   public class HeuristicLabNetronPlugin : PluginBase {
   }
Index: /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/HeuristicLab.Netron-3.0.2672.12446/NetronVisualization.cs
===================================================================
--- /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/HeuristicLab.Netron-3.0.2672.12446/NetronVisualization.cs	(revision 4067)
+++ /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/HeuristicLab.Netron-3.0.2672.12446/NetronVisualization.cs	(revision 4068)
@@ -21,10 +21,6 @@
 
 using System;
-using System.Collections.Generic;
 using System.ComponentModel;
 using System.Drawing;
-using System.Data;
-using System.Linq;
-using System.Text;
 using System.Windows.Forms;
 
Index: /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/HeuristicLab.Netron-3.0.2672.12446/Properties/AssemblyInfo.cs
===================================================================
--- /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/HeuristicLab.Netron-3.0.2672.12446/Properties/AssemblyInfo.cs	(revision 4067)
+++ /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/HeuristicLab.Netron-3.0.2672.12446/Properties/AssemblyInfo.cs	(revision 4068)
@@ -1,4 +1,3 @@
 ﻿using System.Reflection;
-using System.Runtime.CompilerServices;
 using System.Runtime.InteropServices;
 
Index: /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/HeuristicLab.Netron-3.0.2672.12446/TextEditor.cs
===================================================================
--- /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/HeuristicLab.Netron-3.0.2672.12446/TextEditor.cs	(revision 4067)
+++ /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/HeuristicLab.Netron-3.0.2672.12446/TextEditor.cs	(revision 4068)
@@ -30,10 +30,7 @@
 
 using System;
-using System.Collections.Generic;
-using System.Linq;
-using System.Text;
+using System.Drawing;
+using System.Windows.Forms;
 using Netron.Diagramming.Core;
-using System.Windows.Forms;
-using System.Drawing;
 
 namespace HeuristicLab.Netron {
Index: /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/HeuristicLab.Netron-3.0.2672.12446/View.cs
===================================================================
--- /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/HeuristicLab.Netron-3.0.2672.12446/View.cs	(revision 4067)
+++ /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/HeuristicLab.Netron-3.0.2672.12446/View.cs	(revision 4068)
@@ -30,10 +30,6 @@
 
 using System;
-using System.Collections.Generic;
-using System.Linq;
-using System.Text;
+using System.Drawing;
 using Netron.Diagramming.Core;
-using System.Drawing;
-using System.Drawing.Drawing2D;
 
 namespace HeuristicLab.Netron {
Index: /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/Netron.Diagramming.Core-3.0.2672.12446/Analysis/Connection.Analysis.cs
===================================================================
--- /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/Netron.Diagramming.Core-3.0.2672.12446/Analysis/Connection.Analysis.cs	(revision 4067)
+++ /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/Netron.Diagramming.Core-3.0.2672.12446/Analysis/Connection.Analysis.cs	(revision 4068)
@@ -1,62 +1,49 @@
-using System;
-using System.Collections.Generic;
-using System.Text;
 using Netron.Diagramming.Core.Analysis;
-namespace Netron.Diagramming.Core
-{
-    public partial class Connection : IEdge
-    {
-        #region Fields
-        private bool mIsDirected = false;
+namespace Netron.Diagramming.Core {
+  public partial class Connection : IEdge {
+    #region Fields
+    private bool mIsDirected = false;
 
-        #endregion
+    #endregion
 
 
-        bool IEdge.IsDirected
-        {
-            get { return mIsDirected; }
-            set { mIsDirected = value; }
-        }
+    bool IEdge.IsDirected {
+      get { return mIsDirected; }
+      set { mIsDirected = value; }
+    }
 
-        INode IEdge.SourceNode
-        {
-            get {
-                if (From.AttachedTo == null)
-                    return null;
-                else
-                    return From.AttachedTo.Parent as INode;
-            }
-        }
+    INode IEdge.SourceNode {
+      get {
+        if (From.AttachedTo == null)
+          return null;
+        else
+          return From.AttachedTo.Parent as INode;
+      }
+    }
 
-        INode IEdge.TargetNode
-        {
-            get {
-                if (To.AttachedTo == null)
-                    return null;
-                else
-                    return To.AttachedTo.Parent as INode; 
-            }
-        }
+    INode IEdge.TargetNode {
+      get {
+        if (To.AttachedTo == null)
+          return null;
+        else
+          return To.AttachedTo.Parent as INode;
+      }
+    }
 
-        INode IEdge.AdjacentNode(INode node)
-        {
-            if (From.AttachedTo != null && (node as IShape) == From.AttachedTo.Parent)
-            {
-                if (To.AttachedTo == null)
-                    return null;
-                else
-                    return To.AttachedTo.Parent as INode;
-            }
-            else if (To.AttachedTo.Parent != null && (node as IShape) == To.AttachedTo.Parent)
-            {
-                if (From.AttachedTo == null)
-                    return null;
-                else
-                    return From.AttachedTo.Parent as INode;
-            }
-            else
-                throw new InconsistencyException("The given node is not part of the edge.");
+    INode IEdge.AdjacentNode(INode node) {
+      if (From.AttachedTo != null && (node as IShape) == From.AttachedTo.Parent) {
+        if (To.AttachedTo == null)
+          return null;
+        else
+          return To.AttachedTo.Parent as INode;
+      } else if (To.AttachedTo.Parent != null && (node as IShape) == To.AttachedTo.Parent) {
+        if (From.AttachedTo == null)
+          return null;
+        else
+          return From.AttachedTo.Parent as INode;
+      } else
+        throw new InconsistencyException("The given node is not part of the edge.");
 
-        }
     }
+  }
 }
Index: /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/Netron.Diagramming.Core-3.0.2672.12446/Analysis/IEdge.cs
===================================================================
--- /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/Netron.Diagramming.Core-3.0.2672.12446/Analysis/IEdge.cs	(revision 4067)
+++ /trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.Netron/3.0.2672.12446/Netron.Diagramming.Core-3.0.2672.12446/Analysis/IEdge.cs	(revision 4068)
@@ -1,31 +1,26 @@
-using System;
-using System.Collections.Generic;
-using System.Text;
 
-namespace Netron.Diagramming.Core.Analysis
-{
+namespace Netron.Diagramming.Core.Analysis {
+  /// <summary>
+  /// Describes a connection from the point of view of graph analysis.
+  /// </summary>
+  public interface IEdge {
     /// <summary>
-    /// Describes a connection from the point of view of graph analysis.
+    /// Indicates if this edge is directed or undirected.
     /// </summary>
-    public interface IEdge
-    {
-        /// <summary>
-        /// Indicates if this edge is directed or undirected.
-        /// </summary>
-        bool IsDirected { get; set;}
-        /// <summary>
-        /// Returns the first, or source, node upon which this Edge is incident.
-        /// </summary>
-        INode SourceNode { get;}
-        /// <summary>
-        /// Returns the second, or target, node upon which this Edge is incident.
-        /// </summary>
-        INode TargetNode { get;}
-        /// <summary>
-        /// Given a Node upon which this Edge is incident, the opposite incident
-        /// Node is returned. Throws an exception if the input node is not incident
-        /// on this Edge.
-        /// </summary>
-        INode AdjacentNode(INode node);
-    }
+    bool IsDirected { get; set; }
+    /// <summary>
+    /// Returns the first, or source, node upon which this Edge is incident.
+    /// </summary>
+    INode SourceNode { get; }
+    /// <summary>
+    /// Returns the second, or target, node upon which this Edge is incident.
+    /// </summary>
+    INode TargetNode { get; }
+    /// <summary>
+    /// Given a Node upon which this Edge is incident, the opposite incident
+    /// Node is returned. Throws an exception if the input node is not incident
+    /// on this Edge.
+    /// </summary>
+    INode AdjacentNode(INode node);
+  }
 }
